diff --git a/CHANGELOG.md b/CHANGELOG.md
index 1e7edbf08b..34368bf958 100644
--- a/CHANGELOG.md
+++ b/CHANGELOG.md
@@ -11,6 +11,7 @@ All notable changes to the Pony compiler and standard library will be documented
 - Back pressure notifications now given when encountered while sending data during `TCPConnection` pending writes
 - Improve efficiency of muted TCPConnection on non Windows platforms (PR #1477)
 - Compiler assertion failure during type checking
+- Runtime memory allocator bug
 
 ### Added
 
diff --git a/src/libponyrt/ds/fun.c b/src/libponyrt/ds/fun.c
index 7c6ca3b2b9..09da215cf6 100644
--- a/src/libponyrt/ds/fun.c
+++ b/src/libponyrt/ds/fun.c
@@ -127,7 +127,7 @@ size_t ponyint_next_pow2(size_t i)
     i = 32;
   else
 #  endif
-    i = __pony_clz(i);
+    i = __pony_clzl(i);
   return 1 << (i == 0 ? 0 : 32 - i);
 #else
   i--;
diff --git a/src/libponyrt/mem/pool.c b/src/libponyrt/mem/pool.c
index 413e437a53..7e478b885f 100644
--- a/src/libponyrt/mem/pool.c
+++ b/src/libponyrt/mem/pool.c
@@ -700,7 +700,17 @@ size_t ponyint_pool_index(size_t size)
   if(size > POOL_MAX)
     return POOL_COUNT;
 
-  return ((size_t)64 - __pony_clzl(size)) - POOL_MIN_BITS;
+  size_t bits;
+#ifdef ILP32
+  bits = 31;
+#else
+  bits = 63;
+#endif
+
+  size_t index = bits - __pony_clzl(size);
+  if(index != (size_t)__pony_ctzl(size))
+    index++;
+  return index - POOL_MIN_BITS;
 }
 
 size_t ponyint_pool_size(size_t index)
